//============================================================================
//  MetaStock MSX  Borland Delphi
//
//         MSX Version 1
//   DLL.
//============================================================================

library DelDll;   //     .DLL file
                  //    DelDll    dll
Uses SysUtils,    //    szString   
     Math;        //    

{$I MSXStruc.inc} //   -  MSX Data Structures.   

//        
//,          dll
//------------------------------------------------------------------------
// MSXInfo
//
//  .         .
//
// :
//
// function MSXInfo (var a_psDLLDef : MSXDLLDef): LongBool; stdcall;
// begin
//   StrLCopy (a_psDLLDef.szCopyright,
//             'Copyright (c) Magical Funcs Inc. 1999', MSX_MAXSTRING-1);  
//   a_psDLLDef.iNFuncs := 2;
//   a_psDLLDef.iVersion := MSX_VERSION;
//   MSXInfo := MSX_SUCCESS;
// end;
//------------------------------------------------------------------------

function MSXInfo (var a_psDLLDef: MSXDLLDef): LongBool; stdcall;
begin
  // :    
  StrLCopy (a_psDLLDef.szCopyright, '<Your copyright goes here>',
            MSX_MAXSTRING-1);  
  // :   ,   
  a_psDLLDef.iNFuncs := 1; //       1 
  a_psDLLDef.iVersion := MSX_VERSION;
  MSXInfo := MSX_SUCCESS;
end;

//------------------------------------------------------------------------
// MSXNthFunction
//
//  .
// MSXNthFunction        MSXInfo function.
//   , a_iNthFunc         
//    a_sFuncDef.szFunctionName   
//        (  )
// : (,     )
//
// function MSXNthFunction (a_iNthFunc: Integer;
//                          var a_psFuncDef: MSXFuncDef): LongBool; stdcall;
//   var l_bRtrn : LongBool;
// begin
//   l_bRtrn := MSX_SUCCESS;
//
//   case a_iNthFunc of
//     0: begin
//          StrCopy(a_psFuncDef.szFunctionName, 'CrystalBall');
//          StrCopy(a_psFuncDef.szFunctionDescription, 'Crystal Ball Function');
//          a_psFuncDef.iNArguments := 2;
//        end;
//     1: begin
//          StrCopy(a_psFuncDef.szFunctionName, 'Smoother');
//          StrCopy(a_psFuncDef.szFunctionDescription, 'Smooth Out The Noise');
//          a_sFuncDef.iNArguments := 1;
//        end;
//     else
//        l_bRtrn := MSX_ERROR;
//   end;
//   MSXNthFunction := l_bRtrn;
// end;
//------------------------------------------------------------------------

function MSXNthFunction (a_iNthFunc: Integer;
                         var a_psFuncDef: MSXFuncDef): LongBool; stdcall;
  var l_bRtrn : LongBool;
begin
  l_bRtrn := MSX_SUCCESS;
  case a_iNthFunc of
    // :   case  (  0)    
    //        ("EmptyFunc")       .
    //         
    0: begin
         StrCopy(a_psFuncDef.szFunctionName, 'EmptyFunc');
         StrCopy(a_psFuncDef.szFunctionDescription, 'Empty Sample Template Function');
         a_psFuncDef.iNArguments := 0;
       end;
  else
    l_bRtrn := MSX_ERROR;
  end;
  MSXNthFunction := l_bRtrn;
end;

//------------------------------------------------------------------------
// MSXNthArg
//
//            
//  ,       
//
// 
// : (      MSXNthFunction)
//
// function MSXNthArg(a_iNthFunc: Integer; a_iNthArg: Integer;
//                    var a_psFuncArgDef: MSXFuncArgDef): LongBool; stdcall;
//  var l_bRtrn : LongBool;
// begin
//  l_bRtrn := MSX_SUCCESS;
//  a_psFuncArgDef.iNCustomStrings := 0; // init just to be nice
//
//  case a_iNthFunc of
//    0: // CrystalBall
//      case a_iNthArg of
//        0: begin  // CrystalBall:Arg0
//             a_psFuncArgDef.iArgType := MSXDataArray;
//             StrCopy(a_psFuncArgDef.szArgName, 'DataArray');
//           end;
//        1: begin  // CrystalBall:Arg1
//             a_psFuncArgDef.iArgType := MSXCustom;
//             a_psFuncArgDef.iNCustomStrings := 6;
//             StrCopy(a_psFuncArgDef.szArgName, 'Clarity');
//           end;
//        else
//          l_bRtrn := MSX_ERROR;
//      end;
//    1: // Smoother
//      case a_iNthArg of
//        0: // Smoother:Arg0
//          begin
//            a_psFuncArgDef.iArgType := MSXNumeric;
//            StrCopy(a_psFuncArgDef.szArgName, 'Periods');
//          end;
//        else
//          l_bRtrn := MSX_ERROR;
//        end;
//   end;
//   MSXNthArg := l_bRtrn;
// end;
//------------------------------------------------------------------------
                         
function MSXNthArg(a_iNthFunc: Integer; a_iNthArg: Integer;
                   var a_psFuncArgDef: MSXFuncArgDef): LongBool; stdcall;
  var l_bRtrn : LongBool;
begin
  l_bRtrn := MSX_SUCCESS;
  a_psFuncArgDef.iNCustomStrings := 0;

  // :      
  //      case

  //case a_iNthFunc of
  //  // :   case       ,
  //  //          case   .          
  //else
  //  l_bRtrn := MSX_ERROR; // This will help MSXTest find errors in your code
  //end;

  MSXNthArg := l_bRtrn;
end;

//------------------------------------------------------------------------
// MSXNthCustomString
//
//              
//     MSXCustom type.
//   ,       
//             
//     
//           .
//     (  reverseIt,  )
//
// If there are only a few strings, you can use a straightforward case with
//   to assign the values. If there are many stings, you can use a local
//   datastructure that contains all the strings.  Both methods are
//   demonstrated here.
//
// First, the normal case approach:
//
// Example (assuming the example from previous functions...)
//
// .......................................................................
// function MSXNthCustomString(a_iNthFunc: Integer;
//                             a_iNthArg: Integer;
//                             a_iNthString: Integer;
//                             var a_psCustomString: MSXFuncCustomString)
//                            : LongBool; stdcall;
//   var l_bRtrn : LongBool;
// begin
//   l_bRtrn := MSX_SUCCESS;
//   
//   case a_iNthFunc of
//     0: // CrystalBall
//       case a_iNthArg of
//         1: // CrystalBall:Arg1
//           case a_iNthString of
//             // note that synonymns for the same option share the same ID.
//             // The CrystalBall function will receive the ID for the custom
//             // parameter, not the string name.  That relieves you of having
//             // to parse and validate the string contents.
//             // If you do need actual string values, use the MSXString type
//             // instead of the MSXCustom type.
//             0: begin
//                  StrCopy(a_psCustomString.szString, 'Smokey');
//                  a_psCustomString.iID := 0;
//                end;
//             1: begin
//                  StrCopy(a_psCustomString.szString, 'S');
//                  a_psCustomString.iID := 0;
//                end;
//             2: begin
//                  StrCopy(a_psCustomString.szString, 'Cloudy');
//                  a_psCustomString.iID := 1;
//                end;
//             3: begin
//                  StrCopy(a_psCustomString.szString, 'C');
//                  a_psCustomString.iID := 1;
//                end;
//             4: begin
//                  StrCopy(a_psCustomString.szString, 'Transparent');
//                  a_psCustomString.iID := 2;
//                end;
//             5: begin
//                  StrCopy(a_psCustomString.szString, 'T');
//                  a_psCustomString.iID := 2;
//                end;
//            else
//              l_bRtrn := MSX_ERROR;
//            end;
//         else
//           l_bRtrn := MSX_ERROR;
//       end;
//     else
//       l_bRtrn := MSX_ERROR;
//   end;
//   MSXNthCustomString := l_bRtrn;
// end;
// ..........................................................................
//
// Now, the datastructure approach
//
// Example (assuming the example from previous functions...)
//
// ..........................................................................
// function MSXNthCustomString(a_iNthFunc: Integer;
//                             a_iNthArg: Integer;
//                             a_iNthString: Integer;
//                             var a_psCustomString: MSXFuncCustomString)
//                            : LongBool; stdcall;
//   // following type and const entries are useful to avoid large case
//   //   statements (if there are many custom string entries)
//   type 
//     CustmStrArray = array[0..39] of Char;
//     LocalStringRec = record
//       CustmString : CustmStrArray;
//       ID          : Integer;
//     end;
// 
//     LocalStringArray = array[0..2] of LocalStringRec; // 0..2 for 3 entries
//   const
//     // init the string array with the custom strings & ID's
//     LocalStrings : LocalStringArray =
//       ((CustmString: 'Smokey'; ID: 0), (CustmString: 'S'; ID: 0),
//        (CustmString: 'Cloudy'; ID: 1), (CustmString: 'C'; ID: 1),
//        (CustmString: 'Transparent'; ID: 2), (CustmString: 'T'; ID: 2)); 
//     // note that in the above structure, synonymns for the same option
//     // share the same ID.  The CrystalBall function will receive the
//     // ID for the custom parameter, not the string name.  That relieves
//     // you of having to parse and validate the string contents.
//     // If you do need actual string values, use the MSXString type instead
//     // of the MSXCustom type.
//   var l_bRtrn : LongBool;
// begin
//   l_bRtrn := MSX_SUCCESS;
//   
//   case a_iNthFunc of
//     0: // CrystalBall
//       case a_iNthArg of
//         1: begin // CrystalBall:Arg1
//              if (a_iNthString >= 0) and (a_iNthString < 2) then
//                begin
//                  StrCopy(a_psCustomString.szString,
//                          LocalStrings[a_iNthString].CustmString);
//                  a_psCustomString.iID := LocalStrings[a_iNthString].ID;
//                end
//            else
//              l_bRtrn := MSX_ERROR;
//            end;
//         else
//           l_bRtrn := MSX_ERROR;
//       end;
//     else
//       l_bRtrn := MSX_ERROR;
//   end;
//   MSXNthCustomString := l_bRtrn;
// end;
//------------------------------------------------------------------------

//        MSXCustom type,      

function MSXNthCustomString(a_iNthFunc: Integer;
                            a_iNthArg: Integer;
                            a_iNthString: Integer;
                            var a_psCustomString: MSXFuncCustomString)
                           : LongBool; stdcall;
   var l_bRtrn : LongBool;
begin
  l_bRtrn := MSX_SUCCESS;
  
  // :       MSXCustom type,    
  //   
  
  // case a_iNthFunc of
  //   // :  case  
  // else
  //  l_bRtrn = MSX_ERROR;
  // end;
  
  MSXNthCustomString := l_bRtrn;
end;

// ************************************************************************
//        ,
//     .
//           
//  Single.
// .. MSX DLL     single    ,  
//          single.
//
//    ,   MSXTest       
// ,       .
// ************************************************************************
function ForceSingleRange (a_lfDbl:Double) : Double;
begin
  if (a_lfDbl > 0.0) then
    begin
      if (a_lfDbl > MaxSingle) then
        a_lfDbl := MaxSingle  //     <= MaxSingle
      else
        if (a_lfDbl < MinSingle) then
          a_lfDbl := MinSingle; //     >= MinSingle
    end
  else
    if (a_lfDbl < 0.0) then
      begin
        if (a_lfDbl < -MaxSingle) then
          a_lfDbl := -MaxSingle  //     >= MaxSingle
        else
          if (a_lfDbl > -MinSingle) then
            a_lfDbl := -MinSingle; //     <= MinSingle
      end;
  ForceSingleRange := a_lfDbl;
end;


//-------------------------------------------------------------------------------------------
//    ,      .
// ,         .
//         a_sDataRec   
//     .
//
//:
//          a_sResult.
//       a_sResult.iFirstValid  a_sResult.iLastValid
//       a_sResult.pfValue[]    a_sResult.iLastValid
//
// :
//
// function CrystalBall (const a_psDataRec: PMSXDataRec;
//                       const a_psDataInfoArgs: PMSXDataInfoRecArgsArray;
//                       const a_psNumericArgs: PMSXNumericArgsArray;
//                       const a_psStringArgs: PMSXStringArgsArray;
//                       const a_psCustomArgs: PMSXCustomArgsArray;
//                       var a_psResultRec: MSXResultRec): LongBool; stdcall;
// 
//   var l_psData      : PMSXDataInfoRec;
//       l_iStartIndex : Integer;
//       l_iMaxIndex   : Integer;
//       l_iClarity    : Integer;
//       i             : Integer;
//       l_bRtrn       : LongBool;
// begin
//   //    2 , 1 DataArray and 1 Custom
//   //    :
//   //   DataArray: a_psDataInfoArgs.psDataInfoRecs[0]
//   //   Custom   : a_psCustomArgs.iCustomIDs[0];
//
//   //     ...
//   if ((a_psDataInfoArgs.iNRecs = 1) and
//       (a_psCustomArgs.iNRecs = 1)) then
//     begin
//       l_bRtrn := MSX_SUCCESS;
//       l_psData := a_psDataInfoArgs.psDataInfoRecs[0];
//       l_iClarity := a_psCustomArgs.iCustomIDs[0];
//       l_iStartIndex := l_psData.iFirstValid;
//       l_iMaxIndex := l_psData.iLastValid;
// 
//       case l_iClarity of
//         0,1,2:
//           begin
//             Randomize;
//             for i := l_iStartIndex to l_iMaxIndex do
//               a_psResultRec.psResultArray.pfValue[i] := Random * 100.0; // What did you expect?
//             a_psResultRec.psResultArray.iFirstValid := l_iStartIndex;
//             a_psResultRec.psResultArray.iLastValid := l_iMaxIndex;
//           end;
//         else
//           begin
//             //   
//             StrLCopy (a_psResultRec.szExtendedError,
//                       'Incorrect custom argument', MSX_MAXSTRING-1);
//             l_bRtrn := MSX_ERROR;
//           end;
//       end;
//     end
//   else
//     begin
//       StrLCopy (a_psResultRec.pszExtendedError,
//                 'Incorrect number of arguments', MSX_MAXSTRING-1);
//       l_bRtrn := MSX_ERROR; //   
//     end;
//   if (l_bRtrn <> MSX_SUCCESS) then
//     begin
//       a_psResultRec.psResultArray.iFirstValid := 0;
//       a_psResultRec.psResultArray.iLastValid := -1;
//     end;
//   CrystalBall := l_bRtrn;
// end;
//-------------------------------------------------------------------------------------------

// :
//  "EmptyFunc"    ,    

function EmptyFunc (const a_psDataRec: PMSXDataRec;
                    const a_psDataInfoArgs: PMSXDataInfoRecArgsArray;
                    const a_psNumericArgs: PMSXNumericArgsArray;
                    const a_psStringArgs: PMSXStringArgsArray;
                    const a_psCustomArgs: PMSXCustomArgsArray;
                    var a_psResultRec: MSXResultRec): LongBool; stdcall;

  var l_bRtrn : LongBool;
begin
  l_bRtrn := MSX_SUCCESS;
  
  //      .    
  //     , ,    
  a_psResultRec.psResultArray.iFirstValid := 0;
  a_psResultRec.psResultArray.iLastValid := -1;


  //       

  EmptyFunc := l_bRtrn;
end;


exports
 MSXInfo,
 MSXNthFunction,
 MSXNthArg,
 MSXNthCustomString,
 //     ,        
 //    ,      
 EmptyFunc;

begin
  //    
end.

